/*
 xGL:XGLcore.h
 Created by mantis on 4/07/05.
 Copyright 2005 xonko interactive. All rights reserved.
 */

#import "XGL.h"
@class XGLView;

@interface XGLCore : NSObject {
	
	IBOutlet XGLView *_glView;
	
	XGLCamera *camera;
	XGLNode *sceneGraph;
	
	NSMutableArray *nodes;
	NSMutableArray *models;
	NSMutableArray *shaders;
	NSMutableArray *lights;
	NSMutableArray *geometries;
	NSMutableArray *textures;
	
}

-(XGLView*)glView;
-(void)setGlView:(XGLView*)newView;

- (BOOL)suspended;
- (void)setSuspended:(BOOL)value;

-(id)newModel;
-(id)newModelWithGeometry:(id)aGeometry;
-(id)newModelWithGeometry:(id)aGeometry andShader:(id)aShader;
-(id)newModelWithGeometry:(id)aGeometry andShader:(id)aShader andName:(id)aName;

-(id)newGeometry;
-(id)newGeometryWithType:(id)geometryType;

-(id)newParticles;

-(id)newShader;
-(id)newShaderWithDiffuse:(id)diffuseColor;
-(id)newShaderWithDiffuse:(id)diffuseColor andTexture:(id)aTexture;

-(id)newTexture;
-(id)newTextureWithImagePathOrName:(NSString *)imagePathOrName;

-(id)newLight;
-(id)newNode;

-(id)modelNamed:(NSString *)name;
-(id)lightNamed:(NSString *)name;
-(id)shaderNamed:(NSString *)name;
-(id)textureNamed:(NSString *)name;
-(id)geometryNamed:(NSString *)name;
-(id)nodeNamed:(NSString *)name;

-(NSArray*)models;
-(NSArray*)shaders;
-(NSArray*)lights;
-(NSArray*)geometries;
-(NSArray*)textures;
-(NSArray*)nodes;

-(NSArray*)parentNodes;

-(id)sceneGraph;
-(void)setSceneGraph:(id)newGraph;

-(XGLCamera *)camera;

-(void)initXGLData;
-(void)resetWorld;
-(void)shutDown;

-(IBAction)toggleInspector:(id)sender;

@end
